package sacooliveros.whatsappweb.bean;

import java.util.Optional;

import org.springframework.context.annotation.Bean;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import it.auties.whatsapp.api.Whatsapp;

@Component
public class WhatsappBean {
    
    Optional<Whatsapp> w = Whatsapp.webBuilder().lastConnection().registered();

    @Bean
    public Whatsapp getWhatsapp() {
        return w.orElse(null);
    }

    @Scheduled(fixedRate = 1000 * 60 )
    public void refreshConnection() {
        if (w.isPresent()) {
            if (!w.get().isConnected()) {
                w.get().connect().join();
            }
        }else{
            w = Optional.empty();
        }
    }

    public void setWhatsapp(Whatsapp whatsapp) {
        w = Optional.ofNullable(whatsapp);
    }

}
